package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {

        int halfLength = string.length() / 2;
        char midChar;

        if (halfLength % 2 == 0) {

            midChar = string.charAt(halfLength);

        } else {

            midChar = string.charAt(halfLength);
        }

        return midChar;
    }

    public static String capitalizeMiddleCharacter(String str) {

        char[] charArray = str.toCharArray();

        charArray[charArray.length / 2] = Character.toUpperCase(charArray[charArray.length / 2]);
        String newStr = new String(charArray);

        return newStr;
    }

    public static String lowerCaseMiddleCharacter(String str) {

        char[] charArray = str.toCharArray();

        charArray[charArray.length / 2] = Character.toLowerCase(charArray[charArray.length / 2]);
        String newStr = new String(charArray);

        return newStr;
    }

    public static Boolean isIsogram(String str) {

        str = str.toLowerCase();
        char array[] = str.toCharArray();
        Arrays.sort(array);

        for (int i = 0; i < str.length() - 1; i++) {

            if (array[i] == array[i + 1])
                return false;
        }

        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {

        for (int i = 1; i < str.length(); i++) {

            if (str.charAt(i) == str.charAt(i - 1))

            return true;
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {

       StringBuilder sb = new StringBuilder();
       String[] array = str.split("");
       String letter = array[0];

        for (int i = 1; i < array.length; i++) {
            String nextLetter = array[i];

            if(letter.equals(nextLetter)) {
                array[i] = "";
                array[i - 1] = "";

            }else{

                letter = array[i];
            }
        }

        for(String s : array) {
            sb.append(s);
        }

        return sb.toString();
    }

    public static String invertCasing(String str) {

        char[] chars = str.toCharArray();

        for (int i = 0; i < chars.length; i++) {
            char newChars = chars[i];

            if (Character.isUpperCase(newChars)) {

                chars[i] = Character.toLowerCase(newChars);

            } else if (Character.isLowerCase(newChars)) {

                chars[i] = Character.toUpperCase(newChars);
            }
        }
        return new String(chars);
    }
}