package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.account.BankAccount;

import java.util.ArrayList;


/**
 * @author leon on 27/12/2018.
 */
public class Bank {

    private ArrayList<BankAccount> bank = new ArrayList<>();

    public BankAccount removeBankAccountByIndex(Integer indexNumber) {

        BankAccount ba = bank.get(indexNumber);

        bank.remove(ba);
        bank.remove(indexNumber);

        return ba;
    }

    public void addBankAccount(BankAccount bankAccount) {

        this.bank.add(bankAccount);

    }

    public Boolean containsBankAccount(BankAccount bankAccount) {

        return this.bank.contains(bankAccount);
    }
}
